



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>F# 语法概览</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">F# 语法概览</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 06:07:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>F#和C#的语法差别</h2>
<p>语法上，F#和C#有两个主要差别：</p>
<ul><li>用缩进而非花括号分隔代码块</li>
<li>用空白而非逗号分隔参数</li></ul>
<h2>F#常见语法元素</h2>
<p>以下是F#代码中常见的语法元素</p>
<h3>注释</h3>
<div>
<pre class="prettyprint linenums">// 这是单行注释<br />
(* 这是多行注释<br />
第二行<br />
最后一行 *)</pre>
</div>
<h3>let 绑定</h3>
<div>
<pre class="prettyprint linenums">let myInt =<br />
let myFloat = 3.14<br />
let myString = "hello"</pre>
</div>
<p>上面的语句没有显式指定 myInt, myFloat, myString 的类型，类型由编译器推断。</p>
<h3>列表</h3>
<div>
<pre class="prettyprint linenums">let twoToFive = [;;;]        // 方括号表示列表，元素用分号分隔<br />
let oneToFive =  :: twoToFive   // 符号 :: 将值添加到列表头部，得到新列表，结果为 [1;2;3;4;5]<br />
let zeroToFive = [;] @ twoToFive   // 符号 @ 连接两个列表，得到新列表，结果为 [0;1;2;3;4;5]</pre>
</div>
<p>务必注意，列表元素使用分号分隔，而非逗号分隔。</p>
<h3>函数</h3>
<p>命名函数用 let 关键字定义，匿名函数用 fun 关键字定义。</p>
<div>
<pre class="prettyprint linenums">let square x = x * x          // 使用 let 定义命名函数，函数形参不用小括号围住<br />
square                       // 运行函数，实参也没有小括号

let add x y = x + y           // 不可使用 (x,y)<br />
add                         // 运行函数

// 多行函数，用缩进，不用分号<br />
let evens list =<br />
   let isEven x = x% =      // 内部函数<br />
   List.filter isEven list    // List.filter 是库函数

evens oneToFive               // 运行函数

// 用小括号指明优先级<br />
let sumOfSquaresTo100 =<br />
   List.sum (List.map square [..]) // 如果没有小括号，那么 List.map 会是 List.sum 的参数

// 管道 |&gt;，将操作的输出传给下一个操作<br />
let sumOfSquaresTo100piped =<br />
   [..] |&gt; List.map square |&gt; List.sum

// 用 fun 关键字定义拉姆达（匿名函数）<br />
let sumOfSquaresTo100withFun =<br />
   [..] |&gt; List.map (fun x-&gt;x*x) |&gt; List.sum</pre>
</div>
<h3>模式匹配</h3>
<p>match..with 用于模式匹配</p>
<div>
<pre class="prettyprint linenums">// 类似于 switch/case<br />let simplePatternMatch =<br />
   let x = "a"<br />
   match x with<br />
    | "a" -&gt; printfn "x is a"<br />
    | "b" -&gt; printfn "x is b"<br />
    | _ -&gt; printfn "x is something else"   // 下划线匹配任意值

// Some(..) 和 None 有点像可空类型（Nullable）<br />
let validValue = Some()<br />
let invalidValue = None

// match..with 匹配 "Some" 和 "None"，同时从 Some 中取出值<br />
let optionPatternMatch input =<br />
   match input with<br />
    | Some i -&gt; printfn "input is an int=%d" i<br />
    | None -&gt; printfn "input is missing"

optionPatternMatch validValue<br />
optionPatternMatch invalidValue</pre>
</div>
<h3>复杂类型</h3>
<p>复杂类型是指元组，记录和联合</p>
<div>
<pre class="prettyprint linenums">// 元组，包含有序但未命名的值，值之间用逗号分隔<br />
let twoTuple = ,2           // 二元组<br />
let threeTuple = "a",,true  // 三元组

// 记录，包含命名的字段，字段之间用分号分隔<br />
type Person = {First:string; Last:string}<br />
let person1 = {First="john"; Last="Doe"}

// 联合，包含选项，选项之间用竖线分隔<br />
type Temp =<br />
    | DegreesC of float<br />
    | DegreesF of float<br />
let temp = DegreesF 98.6

// 类型可以递归的组合，例如，下面的 Employee 联合包含 Employee 类型的列表<br />
type Employee =<br />
  | Worker of Person<br />
  | Manager of Employee list<br />
let jdoe = {First="John";Last="Doe"}<br />
let worker = Worker jdoe</pre>
</div>
<h3>格式化输出</h3>
<p>printf 和 printfn 向控制台输出，类似于 C# Console 类的 Write 和 WriteLine 方法。sprintf 输出到字符串，类似于 String 类的 Format 方法。</p>
<div>
<pre class="prettyprint linenums">printfn "Printing an int %i, a float %f, a bool %b"  2.0 true<br />
printfn "A string %s, and something generic %A" "hello" [;;;]

// 复杂类型具有内置的美观输出格式<br />
printfn "twoTuple=%A,\nPerson=%A,\nTemp=%A,\nEmployee=%A" twoTuple person1 temp worker

let str1 = sprintf "Printing an int %i, a float %f, a bool %b"  2.0 true<br />
let str2 = sprintf "A string %s, and something generic %A" "hello" [;;;]</pre>
</div>
<h2>比较F#和C#：计算平方和</h2>
<p><strong>C#版，不使用 linq</strong></p>
<div>
<pre class="prettyprint linenums">public static class SumOfSquaresHelper<br />
{<br />
   public static int Square(int i)<br />
   {<br />
      return i * i;<br />
   }

   public static int SumOfSquares(int n)<br />
   {<br />
      int sum = ;<br />
      for (int i = ; i &lt;= n; i++)<br />
      {<br />
         sum += Square(i);<br />
      }<br />
      return sum;<br />
   }<br />
}</pre>
</div>
<p><strong>F#版</strong></p>
<div>
<pre class="prettyprint linenums">let square x = x * x<br />
let sumOfSquares n =<br />
   [..n]               // 创建 1 到 n 的列表<br />
   |&gt; List.map square   // 对每个元素求平方，得到新列表<br />
   |&gt; List.sum          // 将平方列表求和</pre>
</div>
<p>F# 语法噪音小，没有花括号，分号，并且在这里不需要显式指定类型。</p>
<p><strong>C#版，使用 linq</strong></p>
<div>
<pre class="prettyprint linenums">public static class FunctionalSumOfSquaresHelper<br />
{<br />
   public static int SumOfSquares(int n)<br />
   {<br />
      return Enumerable.Range(, n)<br />
         .Select(i =&gt; i * i)<br />
         .Sum();<br />
   }<br />
}</pre>
</div>
<p>使用 linq 改写的 C# 代码简洁很多，但不能消除语法噪音，参数和返回值的类型也是必须的，仍然不如 F# 版简洁。</p>
<h2>例子：快速排序算法</h2>
<p>快速排序算法的步骤是：</p>
<ol><li>从列表中取出一个数作为基准</li>
<li>将小于基准的数放在左边，不小于基准的数放在右边</li>
<li>对基准两边的部分进行快速排序</li></ol>
<p>下面是 F# 实现快速排序的例子</p>
<div>
<pre class="prettyprint linenums">let rec quicksort list =<br />
   match list with<br />
   | [] -&gt; []<br />
   | firstElem::otherElements -&gt;  <br />        // 小于第一个元素的元素<br />
        let smallerElements =<br />
            otherElements<br />
            |&gt; List.filter (fun e -&gt; e &lt; firstElem)<br />
            |&gt; quicksort

        // 不小于第一个元素的元素<br />
        let largerElements =<br />
            otherElements<br />
            |&gt; List.filter (fun e -&gt; e &gt;= firstElem)<br />
            |&gt; quicksort           

        // 连接成新列表 <br />        List.concat [smallerElements; [firstElem]; largerElements]

printfn "%A" (quicksort [;;;;;;])</pre>
</div>
<p>如果应用库函数和一些技巧，代码可压缩成：</p>
<div>
<pre class="prettyprint linenums">let rec quicksort = function<br />
   | [] -&gt; []<br />
   | first::rest -&gt;<br />
        let smaller,larger = List.partition ((&gt;=) first) rest<br />
        List.concat [quicksort smaller; [first]; quicksort2 larger]</pre>
</div>
<p>参考网站：<a href="http://fsharpforfunandprofit.com/" rel="external nofollow noreferrer">http://fsharpforfunandprofit.com/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r56edq.html">C&num;设计模式系列：迭代器模式（Iterator）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2y6do8.html">go语言 hello 小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgoew9.html">myeclipse&plus;tomcat内存溢出</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903ylj9.html">oracle SQL查询中间若干条记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2zvelq.html">workerman 的回调函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/m961olv8.html">VIM、GVIM在WINDOWS下中文乱码的终极解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okdr7e9.html">uboot命令分析&plus;实现【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnrj30q.html">一个隐晦的c&plus;&plus;语法问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wev33q.html">vsftpd服务安装，配置，限制目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp02p69.html">BZOJ 1631&colon; &lbrack;Usaco2007 Feb&rsqb;Cow Party</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvn5eq.html">unity3d 多人寻路堵塞堆叠问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4zr1q.html">最全面的Java字节byte操作&comma;处理Java基本数据的转换及进制转换操作工具&comma;流媒体及java底层开发项目常用工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17lrxq.html">golang 栈操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geyrg78.html">OpenResty和Resis一些基本的性能配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge26we8.html">Android 7&period;0及以上使用OpenCL</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zn2eq.html">SpringBoot和druid数据源集成Jpa</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmn259.html">&lbrack;转帖&rsqb;Windows 内核说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zylwzn9.html">JS学习小结（上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvynx38.html">bilibili的直播第三方IJKMediaFramework&period;framework下载打包使用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5xxweq.html">区块链 blockchain</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pdkooz9.html">C&plus;&plus;实现具有基本功能的智能指针</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd4gw8.html">前端自动化构建工具-yoman浅谈</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgy2w78.html">你真的懂ajax吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jm4no8.html">iOS 图片压缩方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy14kkgq.html">office如何去除多页签</a>
			</li>
						<li><a href="https://www.batexi.com/a/950m6068.html">JAVA传值与传址</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljnznk9.html">《解决在Word中为汉子插入拼音及音标的问题》</a>
			</li>
						<li><a href="https://www.batexi.com/a/950m5nm8.html">Python学习--20 Web开发</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdk1049.html">正则表达式中的match，test，exec，search的返回值</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj5n4eq.html">bootstrap-标签页</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
